/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package adatkezeles;

import alaposztalyok.AlkoholosItal;
import alaposztalyok.Ital;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import javax.swing.DefaultListModel;

/**
 *
 * @author :)
 */
public class AdatBazisbolInput implements AdatInput{

    Connection kapcsolat;

    public AdatBazisbolInput(Connection kapcsolat) {
        this.kapcsolat = kapcsolat;
    }
            
    @Override
    public List<Ital> italLista() throws Exception {
        List<Ital> italok = new ArrayList<>();
        // ezt az sql utasítást kell majd végrehajtani
        String sqlUtasitas = "select * from ITALOK";
        
        String fajta, vonalkod, marka;
        int literAr;
        double alkoholFok;

        Ital ital;
        // az utasításobjektum és az eredményhalmaz is lezárandó, ezért
        // a try fejében hozzuk létre őket.
        try (Statement utasitasObjektum = kapcsolat.createStatement();
                ResultSet eredmenyHalmaz = 
                                  utasitasObjektum.executeQuery(sqlUtasitas)) {
            while (eredmenyHalmaz.next()) {
                fajta = eredmenyHalmaz.getString("fajta");
                vonalkod = eredmenyHalmaz.getString("vonalkod");
                literAr = eredmenyHalmaz.getInt("literar");
                marka = eredmenyHalmaz.getString("marka");
                alkoholFok = eredmenyHalmaz.getDouble("alkoholfok");

//                fajta = eredmenyHalmaz.getString(2);
//                vonalkod = eredmenyHalmaz.getString(3);
//                literAr = eredmenyHalmaz.getInt(4);
//                marka = eredmenyHalmaz.getString(5);
//                alkoholFok = eredmenyHalmaz.getDouble(6);
//                
                if(marka == null){
                    ital = new Ital(fajta, vonalkod, literAr);
                }
                else ital = new AlkoholosItal(fajta, vonalkod, 
                                              literAr, marka, alkoholFok);
                
                italok.add(ital);
            }
        }
        return italok;
    }

    @Override
    public DefaultListModel<Ital> italModell() throws Exception {
        // lehet úgy is, hogy üresen - vagy a figyelmeztető üzenettel hagyjuk
        // valamelyik metódust
        DefaultListModel<Ital> italModel = new DefaultListModel<>();
        List<Ital> templist = italLista();
        for (Ital ital : templist) {
            italModel.addElement(ital);
        }
        return  italModel;
    }    
    
}
